sunny20102 发表于 2012-11-8 11:03:21

获取面域特性_[已解决]

本帖最后由 sunny20102 于 2012-11-20 08:02 编辑

      static void massmass(void)
      {
                // Add your code for command mass.mass here
                ads_name en;
                ads_point pt;
                if(acedEntSel(_T(""),en,pt)!=RTNORM)
                        return;
                AcDbObjectId id;
                acdbGetObjectId(id,en);
                AcDbRegion *pEnt;
                acdbOpenObject(pEnt,id,AcDb::kForRead);
                if(!pEnt->isKindOf(AcDbRegion::desc()))
                {
                        acutPrintf(_T("\n所选择实体非面域!"));
                        pEnt->close();
                        return;
                }

                AcGePoint3d origin;
                AcGeVector3d xAxis;
                AcGeVector3d yAxis;
                double perimeter;
                double area;
                AcGePoint2d centroid;
                double momInertia;
                double prodInertia;
                double prinMoments;
                AcGeVector2d prinAxes;
                double radiiGyration;
                AcGePoint2d extentsLow;
                AcGePoint2d extentsHigh;

                pEnt->getAreaProp(origin,xAxis,yAxis,perimeter,area,centroid,momInertia,prodInertia,prinMoments,prinAxes,radiiGyration,extentsLow,extentsHigh);
               
                acutPrintf(_T("\n      Area: %f"),area);
                acutPrintf(_T("\n Perimeter: %f"),perimeter);
                pEnt->close();
      }

sunny20102 发表于 2012-11-8 11:06:28

先创建了 100x50x3 的矩形管,
加载运行后结果如下:d:\1.png

sunny20102 发表于 2012-11-8 11:07:27

图片只会用附件上传

sunny20102 发表于 2012-11-8 14:41:43

已解决,查看arxref.hlp文件,查acdbregion->getareaprop原形,知道,
需要校验 origin xAxis yAxis 值,并检查x y是否垂直
添加如下代码编译通过
                        origin=origin=origin=0;
                        xAxis=1;xAxis=xAxis=0;
                        yAxis=1;yAxis=yAxis=0;

sunny20102 发表于 2012-11-19 11:12:11

这几天摸索着搞成了个半成品,还差Sx Sy,
效果如下:

sunny20102 发表于 2012-11-19 11:15:53

需要的可以测试下附件所带的 arx
注: 仅Autocad2010_x86

sunny20102 发表于 2012-11-20 08:04:27

已解决了Sx Sy的计算问题,详附件
这个是学习ObjectArx 编的第一个程序

sunny20102 发表于 2012-11-20 10:14:14

经过同事试用,发现加载并运行mass后,保存时会出现问题
解决办法: 用 -wblock保存

还是不完美,可能是那个指针出问题了. 错误提示如下:

sunny20102 发表于 2012-11-20 10:16:28

个人独自学习objectarx ,特别是c++基础薄弱的情况下,进展很缓慢,事倍功半
高手都潜水了, 加之本版块比较冷清
有人指点下就感激不尽了
页: [1]
查看完整版本: 获取面域特性_[已解决]